<?php
/**
 * @version $Id$
 * @package Jobline
 * @subpackage Jx Show Jobs
 * @description Jx Show Jobs shows job postings from the Jobline component.
 * @Copyright (C) 2008 Olle Johansson
 * @ Released under GNU/GPL License v2 : http://www.gnu.org/copyleft/gpl.html
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


if ( !defined( '_JXSHOWJOBS_MODULE' ) ) {
	define( '_JXSHOWJOBS_MODULE', 1 );

	function modJxShowJobs( &$params ) {
		global $mosConfig_absolute_path, $database, $my;

        // Sanity check on column field, needs to be at least 1.
		$columns = intval( $params->get( 'columns' ) );
		if ( !$columns ) {
			$columns = 1;
		}

		$count = intval( $params->get( 'count' ) );

		$nullDate 	= $database->getNullDate();
		$now = _CURRENT_SERVER_TIME;

		$query = "SELECT id FROM #__menu WHERE link='index.php?option=com_jobline' AND published=1";
		$database->setQuery( $query );
		$Itemid = $database->loadResult();

        // Set up what to order by
		$ascordesc = ( $params->get( 'sortreverse' ) ) ? "DESC" : "ASC";
		switch( $params->get( 'sortby' ) ) {
			case "date": $orderby = "created"; break;
			case "title": $orderby = "title"; break;
			case "hits": $orderby = "hits"; break;
			default: $orderby = "ordering";
		}

		// Check out of we need to show only published items
		$publishedquery = "";
		include( "$mosConfig_absolute_path/components/com_jobline/configuration.php" );
		if ( $cfgjl['publishinglimit'] > 0 ) {
			$ptime = date( "Y-m-d H:i:s", time() - intval( $cfgjl['publishinglimit'] ) * 86400 );
			$publishedquery = "\n	AND created >= '$ptime'";
		}

		$query = "SELECT id, title, hits, description"
			. "\nFROM #__jl_jobposting"
			. "\nWHERE state = 1 AND access <= '$my->gid'"
			#. "\n AND ( publish_up = '$nullDate' OR publish_up <= '$now' )"
			#. "\n AND ( publish_down = '$nullDate' OR publish_down >= '$now' )"
			. "$publishedquery"
			. "\nORDER BY $orderby $ascordesc";
		$database->setQuery( $query, 0, $count );
		#print $database->getQuery();
		$rows = $database->loadObjectList();
		$rowcount = count( $rows );

		$tablerows = ceil( $rowcount / $columns );

        // cycle through the returned rows displaying them in a table
        // with links to the content item
        // escaping in and out of php is now permitted
?>
<?php echo $params->get( 'pretext' ); ?>
<?php
if ( $rowcount == 0 ) {
	echo $params->get( 'lang_noitems' );
} else {
?>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
<tr>
<?php for ( $j = 0, $i = 0; $j < $columns; $j++ ) { ?>
<?php $start = $j * $tablerows; ?>
<td valign="top">

<table cellpadding="1" cellspacing="1" border="0">
<?php for ( $i = $start, $k = 0; $i < $rowcount && $k < $tablerows; $i++, $k++ ) { ?>
<?php $row = $rows[$i]; ?>
	<tr>
		<td valign="top"><?php echo $params->get( 'preitem' ); ?></td>
		<td>
          <a href="<?php echo sefRelToAbs( "index.php?option=com_jobline&task=view&Itemid=$Itemid&id=$row->id" ); ?>"><?php echo $row->title ?></a>
		  <?php if ( $params->get( 'showhits') ) { echo "($row->hits)"; } ?>
		  <?php if ( $params->get( 'showdescr') ) { echo "<br />$row->description"; } ?>
          <?php echo $params->get( 'postitem' ); ?>
        </td>
	</tr>
<?php
}
?>
</table>

</td>
<?php } ?>
</tr>
</table>
<?php } ?>
<?php echo $params->get( 'posttext' ); ?>

<?php

	}
}

// get params definitions

$params->def( 'count', 5 );
$params->def( 'showhits', 0 );
$params->def( 'showdescr', 0 );
$params->def( 'sortreverse', 0 );
$params->def( 'sortby', 'title' );
$params->def( 'preitem', '' );
$params->def( 'postitem', '' );
$params->def( 'pretext', '' );
$params->def( 'posttext', '' );
$params->def( 'columns', 1 );
$params->def( 'lang_noitems', 'No items' );

// Call the function to show the jobs.
modJxShowJobs( $params );

?>